#include <iostream>
#include "Camera.h"
#include "Matrix.h"
//#include "Vector.h"


Camera::Camera(Vector & eye, Vector & look, Vector & up) {
	this->eye=eye;
	this->look=look;
	this->up=up;
}

Camera::Camera() {
	this->eye=Vector();
	this->look=Vector();
	this->up=Vector();
}

Camera::~Camera(void) {

}

Vector Camera::center() {
	return this->eye + this->look;
}
/*
Camera Camera::rotateAroundOriginX(GLfloat theta) {
	return Camera(RotateXMatrix(theta)*eye, look, up);
}

Camera Camera::rotateAroundOriginY(GLfloat theta) {
	return Camera(RotateYMatrix(theta)*eye, look, up);
}

Camera Camera::rotateAroundOriginZ(GLfloat theta) {
	return Camera(RotateZMatrix(theta)*eye, look, up);
}
*/

Camera Camera::rotateX(GLfloat theta) {
	return Camera(eye, RotateXMatrix(theta)*look, up);
}

Camera Camera::rotateY(GLfloat theta) {
	return Camera(eye, RotateYMatrix(theta)*look, up);
}

Camera Camera::rotateZ(GLfloat theta) {
	return Camera(eye, RotateZMatrix(theta)*look, up);
}

Camera Camera::translate(GLfloat x, GLfloat y, GLfloat z) {
	return Camera(TranslateMatrix(x, y, z)*eye, look, up);
}

Camera Camera::translate(const Vector & v) {

	return Camera(TranslateMatrix(v)*eye, look, up);
}


