#ifndef INTVECTORH
#define INTVECTORH

#include <stdio.h>

#include <GL/glut.h>
#include <GL/gl.h>
#include <GL/glu.h>

class Vector;


class IntVector {
	friend bool operator==(const IntVector & a, const IntVector & b) {
		return a.x==b.x && a.y==b.y && a.z==b.z;
	}
	friend bool operator!=(const IntVector & a, const IntVector & b) {
		return a.x!=b.x || a.y!=b.y || a.z!=b.z;
	}
public:
	IntVector(void);
	IntVector(int x, int y, int z);
	virtual ~IntVector(void);
	int IntVector::key() const;
	GLint x;
	GLint y;
	GLint z;
};

inline int IntVector::key() const {
	int yp = (y << 12) ^ (y >> 20);
	int zp = (z << 20) ^ (z >> 12);
	int prod = x ^ yp ^ zp;
	return prod;
}


#endif