#ifndef LANDSCAPETRIANGLEH
#define LANDSCAPETRIANGLEH

#include <stdlib.h>
#include <GL/glut.h>
#include <GL/gl.h>
#include <GL/glu.h>

class Vector;
class Vertex;
class Camera;
class Vector2D;

class LandscapeTriangle {
public:

	LandscapeTriangle(LandscapeTriangle * parent, Vertex * a, Vertex * b, Vertex * c, int level, GLfloat sideLength, bool orientedUp);
	virtual ~LandscapeTriangle(void);
	void draw(Camera * camera, bool locked);
	void subdivide(bool locked, LandscapeTriangle * caller);
	GLfloat getRange();
	bool closeTo(Camera * camera);
	void subdivideNeighbors(LandscapeTriangle * caller);
	bool wasDivided;

	GLfloat getY(GLfloat alpha, GLfloat beta, Vector ** normal);
	bool hit(GLfloat x, GLfloat z, GLfloat * height, Vector ** normal);

	Vector * normal;

	Vertex * corner[3];
	Vertex * edge[3];
	
	LandscapeTriangle * parent;
	LandscapeTriangle * neighbor[3];
	
	int level;
	GLfloat sideLength;
	bool isSubdivided;
	bool orientedUp;

	LandscapeTriangle * outside[3];
	LandscapeTriangle * center;

};

inline int index(int n);
extern void setColor(int c);

#endif