#include "Matrix2D.h"


Matrix2D::Matrix2D(void) {
	a=b=c=d=0;
}

Matrix2D::Matrix2D(GLfloat a, GLfloat b, GLfloat c, GLfloat d) {
	this->a=a;
	this->b=b;
	this->c=c;
	this->d=d;
}

Matrix2D::~Matrix2D(void) {
}


GLfloat Matrix2D::determinant() const {
	return a*d-b*c;
}

Matrix2D Matrix2D::inverse() const {
	GLfloat det=this->determinant();

	return Matrix2D(d/det, -b/det, -c/det, a/det);
}

Matrix2D::Matrix2D(Vector2D u, Vector2D v) {
	this->a=u.x; this->b=v.x;
	this->c=u.z; this->d=v.z;
}