#ifndef MATRIX2DH
#define MATRIX2DH

#include <iostream>

#include <GL/glut.h>
#include <GL/gl.h>
#include <GL/glu.h>

using namespace std;


#include "Vector2D.h"

class Matrix2D {
public:
	Matrix2D();
	Matrix2D(GLfloat a, GLfloat b, GLfloat c, GLfloat d);
	Matrix2D(Vector2D u, Vector2D v);
	GLfloat determinant() const;
	Matrix2D inverse() const;
	virtual ~Matrix2D(void);

	friend Matrix2D operator*(const Matrix2D & A, const Matrix2D & B) {
		return Matrix2D(A.a*B.a + A.b*B.c, A.a*B.b + A.b*B.d, A.c*B.a + A.d*B.c, A.c*B.b + A.d*B.d);
	};

	friend Vector2D operator*(const Matrix2D & A, const Vector2D & v) {
		return Vector2D(A.a*v.x + A.b*v.z, A.c*v.x + A.d*v.z);
	};

private:
	GLfloat a, b, c, d;
};




#endif