#ifndef PARTICLEH
#define PARTICLEH

#include <stdlib.h>
#include <hash_map>

#include <GL/glut.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "Vector.h"
#include "IntVector.h"

using namespace std;

class LandscapeTriangle;

class Particle {
public:
	Particle(Vector pos, Vector vel, LandscapeTriangle * terrain, GLUquadric * quad, hash_map<int, hash_map<int, Particle*> * > * ht1, hash_map<int, hash_map<int, Particle*> * > * ht2);
	virtual ~Particle();
	
	void draw();
	void timeStep();
	bool validPos();
	int key1() const;
	int key2() const;
	int key() const;
	bool valid;
	Vector pos;
	
private:
	IntVector getIV1() const;
	IntVector getIV2() const;
	GLfloat Particle::BoxDistance1() const;
	GLfloat Particle::BoxDistance2() const;

	
	Vector vel;
	LandscapeTriangle * terrain;
	GLUquadric * quad;
	hash_map<int, hash_map<int, Particle*> * > * ht1;
	hash_map<int, hash_map<int, Particle*> * > * ht2;
	
	IntVector iv1;
	IntVector iv2;
};

GLfloat emforce(GLfloat distance);

inline bool invalid(Vector * v);


inline GLint key(GLint x, GLint y, GLint z) {
	return x ^ (y<<12 & y >> 20) ^ (z<<20 & z>>12);
}

inline int Particle::key1() const {
	return iv1.key();
}

inline int Particle::key2() const {
	return iv2.key();
}


#endif