#ifndef VERTEXH
#define VERTEXH

class Vector;
class LandscapeTriangle;

class Vertex
{
public:
	Vertex(Vector * p);
	~Vertex(void);

	

	bool empty() {return sum() == 0;};
	bool full() {return sum() == 6;};
	

	Vector * p;

	Vector * getNormal();
	
	void set_up(int n, LandscapeTriangle * lt); 
	
	void set_down(int n, LandscapeTriangle * lt);
	
	void unset_up(int n); 
	
	void unset_down(int n);

	void draw();
	
private:
	int sum();
	int up_flag[3];
	LandscapeTriangle * up[3];
	
	int down_flag[3];
	LandscapeTriangle * down[3];
	Vector * normal;


	int flagSum;
};



#endif